//Li-fi reciever Borrowed from SaadOjo https://github.com/SaadOjo/DIY_Li-Fi/blob/master/reciever_code/reciever_code.ino

//Reciever setup
#define LDR_PIN A2
#define LED A4
#define SAMPLING_TIME 5

//Keypad Setup
#include "Adafruit_NeoTrellis.h"

Adafruit_NeoTrellis trellis;

int colors[16] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; //0 is off, 1 is on, this holds whole system state

//This is what handels keypresses
//define a callback for key presses
TrellisCallback blink(keyEvent evt) {

  // Turn on/off the neopixels!
  trellis.pixels.show();

  return 0;
}

//Declaration
bool led_state = false;
bool previous_state = true;
bool current_state = true;
char buff[17];

bool stateread = false;
int counter;

//THRESHOLD 
int threshold = 10; //this is the threshold that determines if a bit is set. It might need to be adjusted 

void setup()
{
  pinMode(LED, OUTPUT);
  Serial.begin(9600);

  if (!trellis.begin()) {
    Serial.println("Could not start trellis, check wiring?");
    while (1);
  } else {
    Serial.println("NeoPixel Trellis started");
  }

  //activate all keys and set callbacks
  for (int i = 0; i < NEO_TRELLIS_NUM_KEYS; i++) {
    trellis.activateKey(i, SEESAW_KEYPAD_EDGE_RISING);
    trellis.activateKey(i, SEESAW_KEYPAD_EDGE_FALLING);
    trellis.registerCallback(i, blink);
  }

  //do a little animation to show we're on
  for (uint16_t i = 0; i < trellis.pixels.numPixels(); i++) {
    trellis.pixels.setPixelColor(i, Wheel(map(i, 0, trellis.pixels.numPixels(), 0, 255)));
    trellis.pixels.show();
    delay(50);
  }
  for (uint16_t i = 0; i < trellis.pixels.numPixels(); i++) {
    trellis.pixels.setPixelColor(i, 0x000000);
    trellis.pixels.show();
    delay(50);
  }

}

void loop() {
  trellis.read();  // interrupt management does all the work! :)

  current_state = get_ldr();
  if (!current_state && previous_state)
  {
    sprintf(buff, "%c", get_byte());
    if (buff[0] == '_') {
      stateread = true;
      counter = 0;
      Serial.print("go");
    }
      if (stateread) {
        if (buff[0] == 'Y') {
          //colors[counter]=1;
          Serial.print("yes");
          trellis.pixels.setPixelColor(counter-1, 255, 255, 255);
          counter = counter+1;

        }
        else {
          //colors[counter]=0;
          trellis.pixels.setPixelColor(counter-1, 0, 0, 0);
          counter = counter+1;
        }
        if (counter > 15) {
          stateread = false;
        }
      }
    
    Serial.print(buff);
    Serial.print(stateread);
    trellis.pixels.show();
    //for(int i = 0; i < 16; i++){
    //Serial.println(colors[i]);
    //Serial.print(" ");
  }

  //}

  digitalWrite(LED, current_state);
  previous_state = current_state;
}

bool get_ldr()
{
  bool val = analogRead(LDR_PIN) > threshold ? true : false;
  digitalWrite(LED, val);
  return val;
}

char get_byte()
{
  char data_byte = 0;
  delay(SAMPLING_TIME * 1.5);
  for (int i = 0; i < 8; i++)
  {
    data_byte = data_byte | (char)get_ldr() << i;
    delay(SAMPLING_TIME);
  }
  return data_byte;
}


uint32_t Wheel(byte WheelPos) {
  if (WheelPos < 85) {
    return trellis.pixels.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
  } else if (WheelPos < 170) {
    WheelPos -= 85;
    return trellis.pixels.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  } else {
    WheelPos -= 170;
    return trellis.pixels.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  }
  return 0;
}
